package router

import (
	"github.com/gin-gonic/gin"
	"onvif-agent/integration/zabbixagent"
	"onvif-agent/router/handler"
	"onvif-agent/router/handler/onvif"
)

func SetupRoutes(r *gin.Engine) {
	r.GET("/", handler.Hello)

	onvifGroup := r.Group("/onvif")
	{
		connectionGroup := onvifGroup.Group("/connections")
		{
			connectionGroup.POST("/", onvif.CreateConnection)
			connectionGroup.GET("/", onvif.GetConnections)
			connectionGroup.GET("/:xaddr", onvif.GetConnectionByXaddr)
			connectionGroup.DELETE("/:xaddr", onvif.DeleteConnection)
		}

		subscriptionGroup := onvifGroup.Group("/subscriptions")
		{
			subscriptionGroup.POST("/:xaddr", onvif.CreateEventSubscription)
			subscriptionGroup.POST("/:xaddr/callback", onvif.EventNotifyCallback)
		}
	}

	zabbixGroup := r.Group("/zabbix")
	{
		zabbixGroup.POST("/onvifDeviceDiscovery", zabbixagent.ONVIFDeviceDiscovery)
	}
}
